sampler TextureSampler;

float map[4][4] = { { 1, 9, 3, 11 }, { 13, 5, 15, 7 }, { 4, 12, 2, 10 }, { 16, 8, 14, 6 } };
int ImageHeight;
int ImageWidth;

float4 PixelShaderFunction(float2 texCoord : TEXCOORD) : COLOR
{
    //texCoord = trunc(texCoord * float2(256, 192)) / float2(256, 192);

    float4 Color = tex2D(TextureSampler, texCoord);

    float2 pixelXY = texCoord * float2(ImageWidth, ImageHeight);
    float d = map[fmod(pixelXY.x, 4)][fmod(pixelXY.y, 4)] / 17.0;

    float l = (Color.r + Color.g + Color.b) / 3.0;
    return trunc(float4(l + d, l + d, l + d, 1));
}

technique dither
{
    pass Pass1
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}