sampler TextureSampler;

float Saturation = 0;
float4 TargetColor = 0;

float4 PixelShaderFunction(float2 texCoord : TEXCOORD) : COLOR
{
    float4 color = tex2D(TextureSampler, texCoord);

    if (color.a == 0)
      return color; // Skip transparent pixels.

    // Linearly interpolate from source to target color.
    return lerp(color, TargetColor, Saturation);
}

// Remaps all image colors to a specified target color.
technique saturate
{
    pass Pass1
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}