sampler TextureSampler;

float4 PixelShaderFunction(float2 texCoord : TEXCOORD) : COLOR
{
    float4 color = tex2D(TextureSampler, texCoord);

    if (color.a == 0)
      return color; // Skip transparent pixels.

    float4 sepiaColor = color;
    sepiaColor.r = color.r * 0.393 + color.g * 0.769 + color.b * 0.189;
    sepiaColor.g = color.r * 0.349 + color.g * 0.686 + color.b * 0.168;    
    sepiaColor.b = color.r * 0.272 + color.g * 0.534 + color.b * 0.131;

    return sepiaColor;
}

// Convert the image to a sepia color tone.
technique sepia
{
    pass Pass1
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}