sampler TextureSampler;

float SegmentsPerXAxis = 50;
float SegmentsPerYAxis = 50;

float4 PixelShaderFunction(float2 texCoord : TEXCOORD) : COLOR
{
    float4 Color = tex2D(TextureSampler, texCoord);

    if (Color.a > 0)
        return Color;

    int h = (int)(texCoord.x * SegmentsPerXAxis) % 2;
    int v = (int)(texCoord.y * SegmentsPerYAxis) % 2;
    bool isCheck = (int)(h + v) % 2;

    return isCheck ? float4(0.5, 0.5, 0.5, 0.5) : float4(0.25, 0.25, 0.25, 0.5);
}

technique showTransparency
{
    pass Pass1
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}