sampler TextureSampler;

float lookup[] = { 0.0, 0.0, 0.8, 0.8, 0.8, 1.0 };

float4 PixelShaderFunction(float2 texCoord : TEXCOORD) : COLOR
{
    float x = ((int)(texCoord.x * 256.0)) / 256.0;
    float y = ((int)(texCoord.y * 192.0)) / 192.0;

    float4 Color = tex2D(TextureSampler, float2(x, y));

    float4 simplified = round(Color * 5);
    
    Color.r = lookup[int(simplified.r)];
    Color.g = lookup[int(simplified.g)];
    Color.b = lookup[int(simplified.b)];

    return Color;
}

// Adjust the color palette and resolution to make it look similar to the ZX Spectrum screen.
technique zxspectrum
{
    pass Pass1
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}